
import java.applet.Applet;
import java.awt.*;
import java.net.*;
import java.io.*;

public class CountDown extends Applet implements Runnable
{
	Image numbers;
	Thread anim=null;

	public void init() {
		numbers = getImage(getCodeBase(), "numbers.gif");
		validate();
	}

	public void start() {
		if (anim == null) anim = new Thread(this);
		anim.start();
	}
	
	public void stop() {
		anim = null;
	}

	public void run() {
		while (Thread.currentThread() == anim) {
			repaint();
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				break;
			}
		}
	}

	public void update(Graphics g) {
		paint(g);
	}

	public void paint(Graphics g_screen) {
		Dimension dim=null, d = size();
		Image buffer=null;
		Graphics g=null;
		long t;
		int weeks, days, hour, min, sec;

		if (g == null || d.width != dim.width || d.height != dim.height) {
			dim = d;
			buffer = createImage(d.width, d.height);
			g = buffer.getGraphics();
		}

		t = 1026518410 - System.currentTimeMillis() / 1000;

		weeks = (int)(t / 604800);
		t %= 604800;
		days = (int)(t / 86400);
		t %= 86400;
		hour = (int)(t / 3600);
		t %= 3600;
		min = (int)(t / 60);
		sec = (int)(t % 60);

		g.setColor(Color.white);
		g.fillRect(0, 0, 620, 320);
		draw_int(g, weeks, 0, 1, 120, 40);
		draw_int(g, days, 0, 1, 450, 40);
		draw_int(g, hour, 0, 0, 20, 200);
		draw_int(g, min, 1, 0, 226, 200);
		draw_int(g, sec, 1, 0, 432, 200);

		draw_colon(g, 190, 204);
		draw_colon(g, 396, 204);

		draw_weeks(g, 115, 8);
		draw_days(g, 410, 8);
		draw_hour(g, 70, 168);
		draw_min(g, 280, 168);
		draw_sec(g, 485, 168);

		g_screen.drawImage(buffer, 0, 0, this);
	}

	public void draw_int(Graphics g, int num, int lead_zero,
	  int center, int x, int y) {
		int tens, ones;

		tens = num / 10;
		ones = num % 10;
		if (tens > 0 || lead_zero == 1) {
			if (center == 1) {
				draw_digit(g, tens, x - 43, y);
				draw_digit(g, ones, x + 43, y);
			} else {
				draw_digit(g, tens, x, y);
				draw_digit(g, ones, x + 86, y);
			}
		} else {
			if (center == 1) {
				draw_digit(g, ones, x - 40, y);
			} else {
				draw_digit(g, ones, x + 86, y);
			}
		}
	}

	public void draw_digit(Graphics g, int num, int x, int y) {
		int xpos[] = {-5, 77, 158, 239, 322, 403, 486, 571, 651, 733};
		if (num < 0 || num > 9) return;
		Graphics gclip = g.create(x, y, 80, 87);
		gclip.drawImage(numbers,  - xpos[num], 0, this);
	}


	public void draw_colon(Graphics g, int x, int y) {
		Graphics gclip = g.create(x, y, 34, 80);
		gclip.drawImage(numbers,  -817, -11, this);
	}
	public void draw_weeks(Graphics g, int x, int y) {
		Graphics gclip = g.create(x, y, 91, 26);
		gclip.drawImage(numbers,  -3, -86, this);
	}
	public void draw_days(Graphics g, int x, int y) {
		Graphics gclip = g.create(x, y, 77, 26);
		gclip.drawImage(numbers,  -93, -86, this);
	}
	public void draw_hour(Graphics g, int x, int y) {
		Graphics gclip = g.create(x, y, 77, 26);
		gclip.drawImage(numbers,  -166, -86, this);
	}
	public void draw_min(Graphics g, int x, int y) {
		Graphics gclip = g.create(x, y, 58, 26);
		gclip.drawImage(numbers,  -241, -86, this);
	}
	public void draw_sec(Graphics g, int x, int y) {
		Graphics gclip = g.create(x, y, 58, 26);
		gclip.drawImage(numbers,  -298, -86, this);
	}


}



